extends Node3D


@export var room_size: float = 10

var cursor_2d_lit: Vector2


@onready var cursor: Control = $cursor
@onready var camera: Node3D = $camera


func _ready() -> void:
	pass


func _input(event: InputEvent) -> void:
	if event is InputEventMouseMotion:
		cursor_2d_lit = get_viewport().get_mouse_position()


func _process(delta) -> void:
	if $raycast_left.is_colliding() and $raycast_right.is_colliding():
		var bound_left: float = $raycast_left.get_collision_point().x
		var bound_right: float = $raycast_right.get_collision_point().x
		room_size = abs(bound_left) + abs(bound_right) - 1
	

	var window_size: Vector2 = get_viewport().get_visible_rect().size
	cursor.position = cursor_2d_lit
	
	camera.position.x = ((cursor_2d_lit.x / window_size.x) - 0.5) * room_size
	camera.rotation.x = ((cursor_2d_lit.y / window_size.y) - 0.5) * -1.0

